#pragma once

#include <QAbstractTableModel>
#include "qsacn_global.h"
#include "qsacnuniverse.h"

class QT_EXPORT UniverseModel
    : public QAbstractTableModel
{
    Q_OBJECT
public:
    explicit UniverseModel(QObject *parent = nullptr,
                           QSacnUniverse *universe = nullptr);
    // Model overrides:
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role = Qt::DisplayRole) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;
    QVariant data(const QModelIndex &index,
                  int role = Qt::DisplayRole) const override;
    bool setData(const QModelIndex &index, const QVariant &value,
                 int role = Qt::EditRole) override;
    Qt::ItemFlags flags(const QModelIndex& index) const override;

    /// @brief The data_modes enum
    enum data_modes {
        Decimal,
        Hex,
        Percent
    };
    Q_ENUM(data_modes)
    data_modes dataMode();

public slots:
    void setDataMode(const QString mode);

private:
    QSacnUniverse* universe_;
    data_modes data_mode_;
};
