/*
  device.cpp

  Copyright (c) 2022 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
  */

#include "device.h"

namespace ARTNET {

Device::Device()
{
  /// \cite ARTNET A ArtPollReply packet is broadcast to the Directed Broadcast
  /// address by all Art-Net devices on power up.
  Device::txArtPollReply();  // Always the reference implimentation, never virual.
}


/**
 * @brief Device::rxArtPoll
 */
void Device::rxArtPoll()
{
  /// \todo impliment rxArtPoll
}


/**
 * @brief Device::txArtPollReply
 * @param query
 *
 * Generate and send the reply to an ArtPoll packet
 */
void Device::txArtPollReply(std::shared_ptr<ArtPoll> query)
{
  (void)query;
  /// \todo impliment txArtPollReply
}


/**
 * @brief Device::txArtDiagData
 */
void Device::txArtDiagData()
{
  /// \todo impliment txArtDiagData
}


/**
 * @brief Device::rxArtTimeCode
 */
void Device::rxArtTimeCode()
{
  /// \todo impliment rxArtTimeCode
}


/**
 * @brief Device::txArtTimeCode
 */
void Device::txArtTimeCode()
{
  /// \todo impliment txArtTimeCode
}


/**
 * @brief Device::rxArtCommand
 */
void Device::rxArtCommand()
{
  /// \todo impliment rxArtCommand
}


/**
 * @brief Device::txArtCommand
 */
void Device::txArtCommand()
{
  /// \todo impliment txArtCommand
}


/**
 * @brief Device::rxArtTrigger
 */
void Device::rxArtTrigger()
{
  /// \todo impliment rxArtTrigger
}


/**
 * @brief Device::txArtTrigger
 */
void Device::txArtTrigger()
{
  /// \todo impliment txArtTrigger
}


/**
 * @brief Device::rxArtDmx
 */
void Device::rxArtDmx()
{
  /// \todo impliment rxArtDmx
}


/**
 * @brief Device::txArtDmx
 */
void Device::txArtDmx()
{
  /// \todo impliment txArtDmx
}


/**
 * @brief Device::rxArtNzs
 */
void Device::rxArtNzs()
{
  /// \todo impliment rxArtNzs
}


/**
 * @brief Device::txArtNzs
 */
void Device::txArtNzs()
{
  /// \todo impliment txArtNzs
}


/**
 * @brief Device::rxArtVlc
 */
void Device::rxArtVlc()
{
  /// \todo impliment rxArtVlc
}


/**
 * @brief Device::txArtVlc
 */
void Device::txArtVlc()
{
  /// \todo impliment txArtVlc
}


/**
 * @brief Device::rxArtRdm
 */
void Device::rxArtRdm()
{
  /// \todo impliment rxArtRdm
}


/**
 * @brief Device::txArtRdm
 */
void Device::txArtRdm()
{
  /// \todo impliment txArtRdm
}


/**
 * @brief Device::rxArtRdmSub
 */
void Device::rxArtRdmSub()
{
  /// \todo impliment rxArtRdmSub
}


/**
 * @brief Device::txArtRdmSub
 */
void Device::txArtRdmSub()
{
  /// \todo impliment txArtRdmSub
}

} // namespace ARTNET
